base-4.7.0.2: Basic libraries

Copyright | (c) The University of Glasgow 2001
License | BSD-style (see the file libraries/base/LICENSE)
Maintainer | libraries@haskell.org
Stability | provisional
Portability | portable
Safe Haskell | Trustworthy
Language | Haskell2010

Data.Functor

Description

Functors: uniform action over a parameterized type, generalizing the `map` function on lists.

Synopsis

- class Functor f where
  - fmap :: (a -> b) -> f a -> f b
  - (<$) :: a -> f b -> f a
- ($>) :: Functor f => f a -> b -> f b
- (<$>) :: Functor f => (a -> b) -> f a -> f b
- void :: Functor f => f a -> f ()

# Documentation

class Functor f where

The `Functor` class is used for types that can be mapped over. Instances of `Functor` should satisfy the following laws:

    fmap id  ==  id
    fmap (f . g)  ==  fmap f . fmap g

The instances of `Functor` for lists, `Maybe` and `IO` satisfy these laws.

Minimal complete definition

fmap

Methods

fmap :: (a -> b) -> f a -> f b

(<$) :: a -> f b -> f a infixl 4

Replace all locations in the input with the same value. The default definition is ``fmap` . `const``, but this may be overridden with a more efficient version.

Instances

Functor [] |
Functor IO |
Functor Maybe |
Functor ReadP |
Functor ReadPrec |
Functor STM |
Functor Handler |
Functor ZipList |
Functor ArgDescr |
Functor OptDescr |
Functor ArgOrder |
Functor ((->) r) |
Functor (Either a) |
Functor ((,) a) |
Functor (ST s) |
Functor (Proxy *) |
Arrow a => Functor (ArrowMonad a) |
Functor (ST s) |
Monad m => Functor (WrappedMonad m) |
Functor (Const m) |
Arrow a => Functor (WrappedArrow a b) |

($>) :: Functor f => f a -> b -> f b infixl 4

Flipped version of `<$`.

Since: 4.7.0.0

(<$>) :: Functor f => (a -> b) -> f a -> f b infixl 4

An infix synonym for `fmap`.

void :: Functor f => f a -> f ()

``void` value` discards or ignores the result of evaluation, such as the return value of an `IO` action.